# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class AipFileFormat(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'content_type': 'str',
        'details': 'str',
        'format': 'str',
        'md5': 'str',
        'puid': 'str',
        'version': 'str'
    }

    attribute_map = {
        'content_type': 'contentType',
        'details': 'details',
        'format': 'format',
        'md5': 'md5',
        'puid': 'puid',
        'version': 'version'
    }

    def __init__(self, content_type=None, details=None, format=None, md5=None, puid=None, version=None, local_vars_configuration=None):  # noqa: E501
        """AipFileFormat - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._content_type = None
        self._details = None
        self._format = None
        self._md5 = None
        self._puid = None
        self._version = None
        self.discriminator = None

        if content_type is not None:
            self.content_type = content_type
        if details is not None:
            self.details = details
        if format is not None:
            self.format = format
        if md5 is not None:
            self.md5 = md5
        if puid is not None:
            self.puid = puid
        if version is not None:
            self.version = version

    @property
    def content_type(self):
        """Gets the content_type of this AipFileFormat.  # noqa: E501

        Content type of file  # noqa: E501

        :return: The content_type of this AipFileFormat.  # noqa: E501
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this AipFileFormat.

        Content type of file  # noqa: E501

        :param content_type: The content_type of this AipFileFormat.  # noqa: E501
        :type: str
        """

        self._content_type = content_type

    @property
    def details(self):
        """Gets the details of this AipFileFormat.  # noqa: E501

        Format details of file  # noqa: E501

        :return: The details of this AipFileFormat.  # noqa: E501
        :rtype: str
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this AipFileFormat.

        Format details of file  # noqa: E501

        :param details: The details of this AipFileFormat.  # noqa: E501
        :type: str
        """

        self._details = details

    @property
    def format(self):
        """Gets the format of this AipFileFormat.  # noqa: E501

        Format description of file  # noqa: E501

        :return: The format of this AipFileFormat.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this AipFileFormat.

        Format description of file  # noqa: E501

        :param format: The format of this AipFileFormat.  # noqa: E501
        :type: str
        """

        self._format = format

    @property
    def md5(self):
        """Gets the md5 of this AipFileFormat.  # noqa: E501

        MD5 checksum of file  # noqa: E501

        :return: The md5 of this AipFileFormat.  # noqa: E501
        :rtype: str
        """
        return self._md5

    @md5.setter
    def md5(self, md5):
        """Sets the md5 of this AipFileFormat.

        MD5 checksum of file  # noqa: E501

        :param md5: The md5 of this AipFileFormat.  # noqa: E501
        :type: str
        """

        self._md5 = md5

    @property
    def puid(self):
        """Gets the puid of this AipFileFormat.  # noqa: E501

        Format PUID of file  # noqa: E501

        :return: The puid of this AipFileFormat.  # noqa: E501
        :rtype: str
        """
        return self._puid

    @puid.setter
    def puid(self, puid):
        """Sets the puid of this AipFileFormat.

        Format PUID of file  # noqa: E501

        :param puid: The puid of this AipFileFormat.  # noqa: E501
        :type: str
        """

        self._puid = puid

    @property
    def version(self):
        """Gets the version of this AipFileFormat.  # noqa: E501

        Format version of file  # noqa: E501

        :return: The version of this AipFileFormat.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this AipFileFormat.

        Format version of file  # noqa: E501

        :param version: The version of this AipFileFormat.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AipFileFormat):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AipFileFormat):
            return True

        return self.to_dict() != other.to_dict()
